commit 28caef183fe708e23cf9aeb26f38e92b7c3d160d
Author: freddy77 <freddy77>
Date:   Mon Oct 27 14:23:22 2008 +0000

    improve and fix test for SQLGetData and SQL_C_WCHAR

diff --git a/ChangeLog b/ChangeLog
index 42daf9a..102fd32 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Mon Oct 27 15:21:50 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* TODO.freddy src/odbc/odbc.c src/odbc/unittests/getdata.c:
+	- improve and fix test for SQLGetData and SQL_C_WCHAR
+	- small fix for odbc_prret
+
 Fri Oct 24 10:27:54 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* TODO.freddy: update
 	* src/odbc/sql2tds.c: fix SQL_NTS for SQL_C_WCHAR
@@ -777,4 +782,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2638 2008/10/24 08:29:22 freddy77 Exp $
+$Id: ChangeLog,v 1.2639 2008/10/27 14:23:22 freddy77 Exp $
diff --git a/TODO.freddy b/TODO.freddy
index bdb3a70..9180179 100644
--- a/TODO.freddy
+++ b/TODO.freddy
@@ -49,7 +49,7 @@ Check iso8859-1 for single ??
 test to review
 - data.c (char -> sql_c_char) DONE
 - genparams.c
-- getdata.c ??
+- getdata.c DONE
 - putdata.c ??
 - blob1.c (SQLGetData test with binary -> char and between chars)
 Is it possible to support direct binding for parameters using different
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 1c9cfee..62a1a75 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.502 2008/10/17 08:56:39 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.503 2008/10/27 14:23:23 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -160,8 +160,8 @@ odbc_prret(SQLRETURN ret)
 	static char unknown[32];
 	
 	switch (ret) {
-	case SQL_NULL_DATA:		return "SQL_ERROR or SQL_NULL_DATA";
-	case SQL_DATA_AT_EXEC:		return "SQL_DATA_AT_EXEC or SQL_INVALID_HANDLE";
+	case SQL_ERROR:			return "SQL_ERROR";
+	case SQL_INVALID_HANDLE:	return "SQL_INVALID_HANDLE";
 	case SQL_SUCCESS:		return "SQL_SUCCESS";
 	case SQL_SUCCESS_WITH_INFO:	return "SQL_SUCCESS_WITH_INFO";
 #if ODBCVER >= 0x0300
@@ -4731,7 +4731,7 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 		if (*pcbValue == SQL_NULL_DATA)
 			ODBC_RETURN(stmt, SQL_ERROR);
 		
-		if (is_variable_type(colinfo->column_type) && (fCType == SQL_C_CHAR || fCType == SQL_C_BINARY)) {
+		if (is_variable_type(colinfo->column_type) && (fCType == SQL_C_CHAR || fCType == SQL_C_WCHAR || fCType == SQL_C_BINARY)) {
 			/* avoid infinite SQL_SUCCESS on empty strings */
 			if (colinfo->column_text_sqlgetdatapos == 0 && cbValueMax > 0)
 				++colinfo->column_text_sqlgetdatapos;
diff --git a/src/odbc/unittests/getdata.c b/src/odbc/unittests/getdata.c
index f772605..d827e42 100644
--- a/src/odbc/unittests/getdata.c
+++ b/src/odbc/unittests/getdata.c
@@ -1,6 +1,7 @@
 #include "common.h"
+#include <assert.h>
 
-static char software_version[] = "$Id: getdata.c,v 1.7 2008/06/12 03:10:16 jklowden Exp $";
+static char software_version[] = "$Id: getdata.c,v 1.8 2008/10/27 14:23:23 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -50,6 +51,28 @@ test_err(const char *data, int c_type, const char *state)
 	ResetStatement();
 }
 
+static int lc;
+static int type;
+
+static int
+mycmp(const char *s1, const char *s2)
+{
+	SQLWCHAR buf[128], *wp;
+	unsigned l;
+
+	if (type == SQL_C_CHAR)
+		return strcmp(s1, s2);
+
+	l = strlen(s2);
+	assert(l < (sizeof(buf)/sizeof(buf[0])));
+	wp = buf;
+	do {
+		*wp++ = *s2;
+	} while (*s2++);
+
+	return memcmp(s1, buf, l * lc + lc);
+}
+
 int
 main(int argc, char *argv[])
 {
@@ -59,52 +82,63 @@ main(int argc, char *argv[])
 
 	Connect();
 
-	/* TODO test with VARCHAR too */
-	Command(Statement, "SELECT CONVERT(TEXT,'Prova')");
+	lc = 1;
+	type = SQL_C_CHAR;
 
-	CHK(SQLFetch, (Statement));
+	for (;;) {
+		/* TODO test with VARCHAR too */
+		Command(Statement, "SELECT CONVERT(TEXT,'Prova')");
 
-	/* these 2 tests test an old severe BUG in FreeTDS */
-	if (SQLGetData(Statement, 1, SQL_C_CHAR, buf, 0, NULL) != SQL_SUCCESS_WITH_INFO)
-		ODBC_REPORT_ERROR("Unable to get data");
+		CHK(SQLFetch, (Statement));
 
-	if (SQLGetData(Statement, 1, SQL_C_CHAR, buf, 0, NULL) != SQL_SUCCESS_WITH_INFO)
-		ODBC_REPORT_ERROR("Unable to get data");
+		/* these 2 tests test an old severe BUG in FreeTDS */
+		if (SQLGetData(Statement, 1, type, buf, 0, NULL) != SQL_SUCCESS_WITH_INFO)
+			ODBC_REPORT_ERROR("Unable to get data");
 
-	if (SQLGetData(Statement, 1, SQL_C_CHAR, buf, 3, NULL) != SQL_SUCCESS_WITH_INFO)
-		ODBC_REPORT_ERROR("Unable to get data");
-	if (strcmp(buf, "Pr") != 0) {
-		printf("Wrong data result 1\n");
-		exit(1);
-	}
+		if (SQLGetData(Statement, 1, type, buf, 0, NULL) != SQL_SUCCESS_WITH_INFO)
+			ODBC_REPORT_ERROR("Unable to get data");
 
-	CHK(SQLGetData, (Statement, 1, SQL_C_CHAR, buf, 16, NULL));
-	if (strcmp(buf, "ova") != 0) {
-		printf("Wrong data result 2 res = '%s'\n", buf);
-		exit(1);
-	}
+		if (SQLGetData(Statement, 1, type, buf, 3 * lc, NULL) != SQL_SUCCESS_WITH_INFO)
+			ODBC_REPORT_ERROR("Unable to get data");
+		if (mycmp(buf, "Pr") != 0) {
+			printf("Wrong data result 1\n");
+			exit(1);
+		}
 
-	ResetStatement();
+		CHK(SQLGetData, (Statement, 1, type, buf, 16, NULL));
+		if (mycmp(buf, "ova") != 0) {
+			printf("Wrong data result 2 res = '%s'\n", buf);
+			exit(1);
+		}
 
-	/* test with varchar, not blob but variable */
-	Command(Statement, "SELECT CONVERT(VARCHAR(100), 'Other test')");
+		ResetStatement();
 
-	CHK(SQLFetch, (Statement));
+		/* test with varchar, not blob but variable */
+		Command(Statement, "SELECT CONVERT(VARCHAR(100), 'Other test')");
 
-	if (SQLGetData(Statement, 1, SQL_C_CHAR, buf, 7, NULL) != SQL_SUCCESS_WITH_INFO)
-		ODBC_REPORT_ERROR("Unable to get data");
-	if (strcmp(buf, "Other ") != 0) {
-		printf("Wrong data result 1\n");
-		exit(1);
-	}
+		CHK(SQLFetch, (Statement));
 
-	CHK(SQLGetData, (Statement, 1, SQL_C_CHAR, buf, 16, NULL));
-	if (strcmp(buf, "test") != 0) {
-		printf("Wrong data result 2 res = '%s'\n", buf);
-		exit(1);
-	}
+		if (SQLGetData(Statement, 1, type, buf, 7 * lc, NULL) != SQL_SUCCESS_WITH_INFO)
+			ODBC_REPORT_ERROR("Unable to get data");
+		if (mycmp(buf, "Other ") != 0) {
+			printf("Wrong data result 1\n");
+			exit(1);
+		}
 
-	ResetStatement();
+		CHK(SQLGetData, (Statement, 1, type, buf, 16, NULL));
+		if (mycmp(buf, "test") != 0) {
+			printf("Wrong data result 2 res = '%s'\n", buf);
+			exit(1);
+		}
+
+		ResetStatement();
+
+		if (type != SQL_C_CHAR)
+			break;
+
+		type = SQL_C_WCHAR;
+		lc = sizeof(SQLWCHAR);
+	}
 
 	/* test with fixed length */
 	Command(Statement, "SELECT CONVERT(INT, 12345)");
@@ -144,21 +178,33 @@ main(int argc, char *argv[])
 	/* overflow */
 	test_err("1234567890123456789", SQL_C_LONG,      "22003");
 
+	/* test for empty string from mssql */
 	if (db_is_microsoft()) {
-		Command(Statement, "SELECT CONVERT(TEXT,'')");
+		lc = 1;
+		type = SQL_C_CHAR;
 
-		CHK(SQLFetch, (Statement));
+		for (;;) {
+			Command(Statement, "SELECT CONVERT(TEXT,'')");
 
-		len = 1234;
-		CHK(SQLGetData, (Statement, 1, SQL_C_CHAR, buf, 1, &len));
+			CHK(SQLFetch, (Statement));
 
-		if (len != 0) {
-			fprintf(stderr, "Wrong len returned, returned %ld\n", (long) len);
-			return 1;
-		}
+			len = 1234;
+			CHK(SQLGetData, (Statement, 1, type, buf, lc, &len));
+
+			if (len != 0) {
+				fprintf(stderr, "Wrong len returned, returned %ld\n", (long) len);
+				return 1;
+			}
+
+			if (SQLGetData(Statement, 1, type, buf, lc, NULL) != SQL_NO_DATA)
+				ODBC_REPORT_ERROR("invalid return from SQLGetData");
+			ResetStatement();
 
-		if (SQLGetData(Statement, 1, SQL_C_CHAR, buf, 1, NULL) != SQL_NO_DATA)
-			ODBC_REPORT_ERROR("invalid return from SQLGetData");
+			if (type != SQL_C_CHAR)
+				break;
+			lc = sizeof(SQLWCHAR);
+			type = SQL_C_WCHAR;
+		}	
 	}
 
 	Disconnect();

